# ib.tcl v3.15 by KuNgFo0 - KuNgFo0@techmonkeys.org (infobot/faqs script)


# Installation:
#  Required:
#   Eggdrop v1.4.x or newer
#   TCL v8.2 or newer
#  Recommended:
#   Eggdrop v1.6.x (or latest)
#   TCL v8.3 (or latest)
#  1. Place this file where the rest of your TCLs go (probably
#     the scripts/ sub-directory) and load in in your conf:
#      source scripts/ib.tcl
#  2. Edit all the variables defined below to your liking.
#  3. Create an empty directory that's located under the bot's
#     main directory.  This directory is defined by the
#     $ib_dir variable below.
#  4. Atleast one default database file, set by $ib_database variable
#     below, must exist in the $ib_dir directory.  It can be left
#     empty for now.
#  5. The script will try to load all files located in the $ib_dir
#     directory.  If there is something you don't want loaded, then
#     don't put it in that dir!
#  6. Boot/rehash the eggdrop.
#  7. Commands used in channels must be prefixed with the bot's
#     current nickname. (Not necessary for private msgs).
#     Do  <botnick>, help  to see a list of the commands.


set ib_ver 3.15
# Set next line as the directory where the database files are
# located (no other files should be in the same dir)
set ib_dir "data/"
# Set the next line as the default database to save changes to
set ib_database "main.data"
# Set the next line as the file to store the help text in
set ib_helpfile "help.txt"

# The default value should be ok for the next two:
# Set the next line as the format to display time in (without timezone)
set ib_format_notz "%I:%M:%S%p - %A, %B %d, %Y"
# Set the next line as the format to display time in (with timezone)
set ib_format "$ib_format_notz %Z"

# Set the next line as the channels to run in (* for all)
set ib_chans "*"
# Set the next line as the maxinum number of matches to
# return on searches
set ib_max 5
# Set the next line as the flag required to add/remove
# questions and etc
set ib_flag ""
# Set the next line as how often to save changes to the database
# (in minutes)
set ib_time 10

# Set the next line as the exec command to run for DNS lookups
# (Only if you're running an older eggdrop or not using the nslookup module)
set ib_nslookup_exec "nslookup -silent"

# The default value should be ok for the next three:
# Set the next line as the host for the dict server to use
set ib_dict_serv "dict.org"
# Set the next line as the port for the dict server to use
set ib_dict_port 2628
# Set the next line as the timeout (in seconds) for dict lookups
set ib_dict_timeout 15

# The default value should be ok for the next two:
# Set the next line as the google url to use
set ib_google_url "http://www.google.com/search?btnI=&q="
# Set the next line as the timeout (in seconds) for http lookups
set ib_google_timeout 15

# Set the next block to any particular responses you want the
# bot to make.  Follow the syntax in the examples carefully.
set ib_ai {
 {"Tach*" "hey*" "hi*" "*hallo*"} {
  "Saluton $nick!"
  "hey $nick, what's up?"
 }
  {"cu" "cya" "baba" "* futsch"} {
  "Cyaaaa $nick! And plz come back!"
  "cu"
  "bis bald"
  "yoah, have fun"
 }
 {"*hehe*" "*h3h3*"} {
  "ja sicher, lol"
  "..."
  "omg LOL"
  }
 {"Saluton" "yo *" "sup*" "what's up*" "whats up*"} {
  "whazzap!"
  "sup?!"
  "word up!"
 }
  {"*looser*" "*idiot*" "*depp*" "*doof*" "*bl*d*"} {
  "Selber!"
  "Komm, geh weg!"
  "Ach ja - sonst gehts dir aber schon noch gut?!"
 }
   {"*lol*" "*lol*" "*^^*" "*rofl*"} {
  "LOOL"
  "Ey $nick du witzkecks"
  "Haha"
  "r0fl"
  ":)"
 }
  
   {"*windows*" "*microsoft*" "*suxx*"} {
  "M$ FucK sH1T -flame-"
  "If God lived on Earth, people would knock out all His windows -- Yiddish saying"
  "W1n0z3 suXx!"
 }
    {"*Alex|RK*" "*playerark*" "alexrk"} {
  "King Kool Alex!"
  "Alex wird koenig von Deutschland :P"
  "Alex, der windows rul0r!"
 }
     {"*Crack*"} {
  "Crack checkt das Cybergate"
  "Crack, der junge mit der dicken...   LEITUNG :P"
  "Crack ruleZ!"
 }
     {"*Diye*"} {
  "Der Henneburger"
  "Pass auf, oder der rul0rt dich in 70 weg!"
  "Flauschi is cool!"
 }
    {"*Beck*" "*Beckman*" "*SCHAUFELBAGGER*"} {
  "Beck is der rul0r!"
  "Beck is cool"
  "THXBeck"
  "schaufelbagg0r!"
 }
         {"*Z0ulbot*" "*zoulbot*"} {
  "Cathing your Soul... [Done]"
  "Du bist Terminiert!"
  "gotcha!"
 }
     {"*Elric*" "*Elbone*"} {
  "Elirc is watching you!"
 }
     {"*July*"} {
  "I LOVE JULY"
  "July` the girl - h - the bot i love!"
 }
 {"you there*" "you here*" "you around*" "you awake*" "wake up*"} {
  "I'm here!"
  "Yes, what is it?"
  "Watcha need, $nick?"
 }
 {"thank you*" "thanks*"} {
  "You're welcome, $nick"
 }
  {"*wolf*"} {
  "Yeah - in BF zockt er euch alle ab!"
  "Der lernt auch c++"
 }
 {"you suck*" "bite me*" "screw you*"} {
  "bite my binary rear end!"
  "$nick, shut your mouth"
  "pfft"
 }
 {"du *" "you *"} {
  "I know you are, but what am I?"
 }
 {"8ball *" "Magic 8ball *"} {
  "Ja, mann!" "Sicher!" "Logisch."
  "Nop" "Keine Changse" "null."
  "Woher soll ich des wissen, heisse ich Wiedi?" "Schau dich doch erstmal an :P" "Frag google..."
 }
 {"time*" "spaet*" "*spt*" "*zeit*" "anyone have the time*"} {
  "It is currently [clock format [clock seconds] -format $ib_format]"
 }
 {""} {
  "What?"
  "Huh?"
  "Eh?"
  "Hrm?"
 }

}
# Note, don't delete the last 2 ( "" and "*" ) or change their string-masks,
# but you may change their replies to whatever.

# You may add additional information here
set ib_help {
Infobot by KuNgFo0
Valid commands
------------------

Searching for topics:
 list/find/search/locate <*string*>
Display who set a topic:
 whoset <topic>
Define a topic:
 <topic>
Get the time:
 time [reference]
Get the time in a certain timezone:
 time -tz <timezone> [reference]
Get the time difference between two timezones:
 time -diff <timezone1> <timezone2>
Note: A good place to get time zone abbreviations is http://www.worldtimezone.com
Resolve a hostname or ip:
 dns/nslookup/resolve <host/ip/nick #1> [host/ip/nick #2] ...
Look up a word in dictionary:
 dict/dictionary/define/lookup [-database] <word>
Search on google:
 google <string>
Do a math calculation:
 calc/calculate/expr <expression>
Do a number conversion:
 conv/convert/switch/change <number> [from] <from-type> [to] <to-type>
 Valid conversion types are: int, dec, oct, hex, bin, ip, rgb
 And many other definable types.
Get this help file:
 help

* Users only *
Database:
 Reloading all databases:
  database reload
 Manually saving all databases:
  database save
 Listing loaded databases:
  database list
Adding topics:
 set/learn/add <topic> = <value>
Removing topics:
 unset/forget/delete/del/remove/rem/rm/erase <topic>
Appending to topics:
 append/addon <topic> = <value>
Linking a topic to another topic:
 link/join <dest topic> = <src topic>
Copying topics:
 copy/cp <topic> = <new topic>
Renaming topics:
 move/mv/rename/ren <topic> = <new topic>

Note: Use "<topic> | database" to specify a particular
 database to use (if more than 1 are loaded)
}

# You shouldn't change these, however you may add additional variables
# These are used via %varname in the 'calculate' command
# Example: Mybot, calculate %pi / 2
set ib_const(pi) 3.14159265358979323846 ; # PI
set ib_const(e)  2.7182818284590452354  ; # E
set ib_const(n)  6.0221367e23           ; # Avogadro's number [1/mol]
set ib_const(R)  8.314510               ; # Universal gas constant [J/(mol*K)]
set ib_const(k)  1.380658e-23           ; # Boltzmann's constant [J/K]
set ib_const(G)  6.67259e-11            ; # Universal gravitational constant [N*m^2/kg^2]
set ib_const(h)  6.62606891e-34         ; # Planck's constant [J*s]
set ib_const(c)  2.99792458e8           ; # Speed of light [m/s]

# Conversion formulas - each array is for its own dimension (length, volume, etc).
# Each unit is converted to a standard type by multiplying the value by the factors
# below.  It is then converted from the standard type to any other unit by
# dividing the factors.  The standard unit used must be the same for everything in
# each dimension, and can be anything as long as they are the same.  I used the root
# metric units for most things (meters, liters, grams, etc).
# Note: All strings are matched as regular expressions
# * Prefix with (?c) for units that should be case sensitive
# * Prefix with (.*?) for metric units
# * Append (?:s) for units with an optional plural ending, etc
# * Only use multiplication and division in the formulas, no addition or subtraction
# * It's a very good idea to have all the formulas return values in decimal form
#   ("1" doesn't matter, though)
# Syntax:
#  name abbreviation factor
set ib_conv_unit(length) {
 inch(?:es)?      in     {2.54 / 100}
 foot|feet        ft     {2.54 / 100 * 12}
 mile(?:s)?       mi     {2.54 / 100 * 12 * 5280}
 (.*?)meter(?:s)? (.*?)m 1
}
set ib_conv_unit(volume) {
 pint(?:s)?       pt     {3.785 / 8}
 quart(?:s)?      qt     {3.785 / 4}
 gallon(?:s)?     gal    3.785
 (.*?)liter(?:s)? (.*?)L 1
}
set ib_conv_unit(weight) {
 ounce(?:s)?     oz     28.35
 pound(?:s)?     lbs    453.59
 ton(?:s)?       T      {453.59 * 2000}
 (.*?)gram(?:s)? (.*?)g 1
}
set ib_conv_unit(work) {
 {}                      btu         1055.056
 calorie(?:s)?           cal         4.1868
 foot-?pound(?:s)?       ft-?lbs     1.356
 electron-?volt(?:s)?    eV          1.6021917E-19
 (.*?)watt-?hour(?:s)?   (.*?)w-?hrs 3600.0
 (.*?)watt-?second(?:s)? (.*?)w-?s   1
 (.*?)joule(?:s)?        (.*?)J      1
}
set ib_conv_unit(power) {
 horsepower      hp     746
 volt-?amp(?:s)? va     1
 (.*?)watt(?:s)? (.*?)w 1
}
set ib_conv_unit(time) {
 second(?:s)?      sec(?:s)? 1
 minute(?:s)?      min(?:s)? 60.0
 hour(?:s)?        hr(?:s)?  {60.0 * 60}
 day(?:s)?         {}        {60.0 * 60 * 24}
 week(?:s)?        wk(?:s)?  {60.0 * 60 * 24 * 7}
 year(?:s)?        yr(?:s)?  {60.0 * 60 * 24 * 365}
 decade(?:s)?      {}        {60.0 * 60 * 24 * 365 * 10}
 century|centuries {}        {60.0 * 60 * 24 * 365 * 100}
}
set ib_conv_unit(binary) {
 option metric 2
 (.*?)byte(?:s)? (.*?)b 1
 (.*?)bit(?:s)?  {}     {1.0 / 8}
}

# Misc conversion formulas - these are types that cannot
# be converted by regular multiplication/division of factors.
# The principle is the same as the formulas above, however
# the arrays are broken down into *_from and *_to variables.
# Note: $value is used as the value being converted.
set ib_conv_misc_from(num) {
 option metric 0
 integer|int              {} {[scan $value "%d"]}
 long                     {} {[scan $value "%u"]}
 decimal|dec|float|double {} {[scan $value "%f"]}
 octal|oct                {} {[scan $value "%o"]}
 hexadecimal|hex          {} {[scan $value "%x"]}
 binary|bin               {} {[bin2int $value]}
 ip                       {} {[ip2long $value]}
 rgb                      {} {[rgb2int $value]}
}
set ib_conv_misc_to(num) {
 option metric 0
 integer|int              {} {[format "%d" [ib_int $value]]}
 long                     {} {[format "%u" [ib_int $value]]}
 decimal|dec|float|double {} {[format "%f" $value]}
 octal|oct                {} {[format "%o" [ib_int $value]]}
 hexadecimal|hex          {} {[format "%X" [ib_int $value]]}
 binary|bin               {} {[int2bin [ib_int $value]]}
 ip                       {} {[long2ip [ib_int $value]]}
 rgb                      {} {[int2rgb [ib_int $value]]}
}
set ib_conv_misc_from(temperature) {
 option metric 0
 fahrenheit         F {($value - 32) * 5 / 9.0}
 kelvin             K {$value - 273.15}
 celsius|centigrade C {$value}
}
set ib_conv_misc_to(temperature) {
 option metric 0
 fahrenheit         F {(9 / 5.0 * $value) + 32}
 kelvin             K {$value + 273.15}
 celsius|centigrade C {$value}
}

# Conversion strings to specificially ignore (that conflict with expr)
set ib_conv_ignore {
 e abs acos asin
 atan atan2 ceil 
 cos cosh double 
 exp floor fmod 
 hypot int log 
 log10 pow rand
 round sin sinh 
 sqrt srand tan 
 tanh
}

# Metric conversion factors
# Note: Abbreviations are case sensitive here
# Syntax:
#  mame abbreviation factor
set ib_conv_metric {
 Yotta Y  24
 Zetta Z  21
 Exa   E  18
 Peta  P  15
 Tera  T  12
 Giga  G  9
 Mega  M  6
 Kilo  k  3
 Hecto h  2
 Deca  dk 1

 Deci  d  -1
 Centi c  -2
 Milli m  -3
 Micro   -6
 Nano  n  -9
 Pico  p  -12
 Femto f  -15
 Atto  a  -18
 Zepto z  -21
 Yocto y  -24
}

# No more editing required

proc xrange {xr xr1 xr2} {
 return [join [lrange [split $xr] $xr1 $xr2]]
}

proc xindex {xr xr1} {
 return [join [lrange [split $xr] $xr1 $xr1]]
}

proc validnum {num} {
 return [expr [scan $num "%f%s" a b] == 1]
}

proc parseurl {url} {
 foreach var {protocol user pass server port path cgiargs anchor} { upvar 1 $var $var }
 if {[regexp {([^:]+)://(([^:]+):([^@]+)@)?([^:/\?#]+)(:([0-9]+))?(/([^\?#]+))?(\?([^#]+))?(#(.*))?} $url a protocol b user pass server c port d path e cgiargs f anchor]} {
  if {![validnum $port]} { set port 80 }
  return 1
 } else { return 0 }
}

# Begin Database code

proc ib_fixtopic {arg} {
 regsub -all {[\\\{\}\[\]\"]} $arg {}   arg ; # Bad characters!"
 regsub -all {(\s)+}          $arg {\1} arg ; # Double whitespace
 regsub -all {^\s*|\s*$}      $arg {}   arg ; # Whitespace at ends
 return $arg
}

proc ib_fixdb {arg} {
 global ib_databases
 if {[set i [lsearch -exact [string tolower $ib_databases] [string tolower $arg]]] == -1} { return "error no such database '$arg' loaded" } \
 else { return [lindex $ib_databases $i] }
}

proc ib_fixdata {arg output} {
 global botnick
 if {[string index $output 0] != "#"} { regsub -all -nocase {$output's} $arg "your" arg }
 regsub -all -nocase {$botnick's} $arg "my" arg
 return $arg
}

proc ib_msg {targets arg} {
 foreach target $targets { puthelp "PRIVMSG $target :[ib_fixdata $arg $target]" }
}

proc ib_check {} {
 global ib_dir
 if {![file exists $ib_dir]}          { return "error $ib_dir does not exist" } \
 elseif {![file isdirectory $ib_dir]} { return "error $ib_dir is not a directory" } \
 elseif {![file readable $ib_dir]}    { return "error $ib_dir is unreadable" } \
 elseif {![file writable $ib_dir]}    { return "error $ib_dir is unwritable" }
 return ""
}

proc ib_loadall {output1 output2} {
 global ib_dir ib_databases
 if {[info exists ib_databases]} {
  # Unset current databases first
  foreach database $ib_databases {
   global ib_data_$database
   catch {unset ib_data_$database} #0
  }
 }
 set ib_databases ""
 if {[set error [ib_check]] != ""} {
  if {$output1 == ""} { putlog $error } \
  else { ib_msg $output1 $error }
 } else {
  foreach file [glob -nocomplain [file join $ib_dir *]] {
   if {[file isfile $file]} {
    if {[xindex [set output [ib_load [file tail $file]]] 0] == "error"} {
     if {$output1 == ""} { putlog $output } \
     else { ib_msg $output1 $output }
    } else {
     if {$output2 == ""} { putlog $output } \
     else { ib_msg $output2 $output }
    }
   }
  }
 }
}

proc ib_load {database} {
 global ib_dir ib_databases ib_data_$database
 set file [file join $ib_dir $database]
 if {([string match *..* $database]) || ([string index $database 0] == "/")} { return "error invalid database name '$database'" } \
 elseif {![file exists $file]}                                               { return "error database '$database' does not exist" } \
 elseif {![file isfile $file]}                                               { return "error database '$database' is not a valid file" } \
 elseif {[catch {open $file r} fileid]}                                      { return "error could not read database '$database'" } \
 else {
  catch {unset ib_data_$database} 0
  while {![eof $fileid]} {
   if {[gets $fileid read] > 0} { set ib_data_${database}([lindex $read 0]) [lindex $read 1] }
  }
  close $fileid
  lappend ib_databases $database
  return "read database '$database'"
 }
}

proc ib_saveall {output1 output2} {
 global ib_databases ib_save
 set error 0
 if {[set output [ib_check]] != ""} {
  if {$output1 == ""} { putlog $error } \
  else { ib_msg $output1 $output }
  set error 1
 } else {
  foreach database $ib_databases {
   if {[xindex [set output [ib_save $database]] 0] == "error"} {
    if {$output1 == ""} { putlog $output } \
    else { ib_msg $output1 $output }
    set error 1
   } else {
    if {$output2 == ""} { putlog $output } \
    else { ib_msg $output2 $output }
   }
  }
 }
 set ib_save $error
}

proc ib_save {database} {
 global ib_dir ib_databases ib_data_$database
 if {[catch {open [file join $ib_dir $database] w} fileid]} { return "error could not write database 'database'" } \
 else {
  foreach topic [lsort [array names ib_data_$database]] { puts $fileid [list $topic [set ib_data_${database}($topic)]] }
  close $fileid
  return "wrote database '$database'"
 }
}

proc ib_needsave {} {
 global ib_save
 set ib_save 1
}

proc time_ib {} {
 global ib_time ib_save
 if {$ib_save} { ib_saveall "" "" }
 if {![string match *time_ib* [timers]]} { timer $ib_time time_ib }
}

proc ib_topics {arg} {
 set topics ""
 set arg    [string trimright $arg "?! "]
 set length [llength $arg]
 for {set l $length} {$l > 0} {incr l -1} {
  for {set i [expr $length - $l]} {$i >= 0} {incr i -1} {
   if {[lsearch -exact [string tolower $topics] [string tolower [set topic [lrange $arg $i [expr $i + $l - 1]]]]] == -1} { lappend topics $topic }
  }
 }
 return $topics
}

# {"topic 1" "topic 2" ...} -> ib_find -> {"database" "first topic found"}
# note: databases are not checked for validity
proc ib_find {topics} {
 global ib_databases
 foreach topic $topics {
  set topic [ib_fixtopic $topic]
  foreach database $ib_databases {
   if {[xindex [set topic2 [ib_exists $topic $database 1]] 0] != "error"} { return [list $database $topic2] }
  }
 }
}

# "*topic string*" -> ib_find2 -> { {"database" "topic found 1"} {"database" "topic found 2"} ... }
proc ib_find2 {topic} {
 global ib_databases
 set topic  [ib_fixtopic $topic]
 set topics ""
 foreach database $ib_databases {
  global ib_data_$database
  foreach topic2 [array names ib_data_$database] {
   if {[string match -nocase *$topic* $topic2]} { lappend topics [list $database $topic2] }
  }
 }
 return $topics
}

proc ib_parsetopic {arg var1 var2} {
 global $var1 $var2
 set i     [string first "=" $arg]
 set $var1 [string trim [string range $arg 0 [expr $i - 1]] " "]
 set $var2 [string trim [string range $arg [expr $i + 1] end] " "]
 for {set i 1} {$i <= 2} {incr i} {
  if {[string match "topic*" [set topic_var [set var$i]]]} {
   # if this is a topic, we look for a database too
   set database_var "database[string range $topic_var 5 end]"
   if {[xindex [set error [ib_parsedb [set $topic_var] $topic_var $database_var]] 0] == "error"} { return $error } ; # we got an error parsing the db
  }
 }
 if {([set $var1] == "") || ([set $var2] == "") || ($i == -1)} { return "error parsing sentence" }
}

proc ib_parsedb {arg var1 var2} {
 global ib_database $var1 $var2
 if {[set i [string last "|" $arg]] != -1} {
  set $var1 [string trim [string range $arg 0 [expr $i - 1]] " "]
  set $var2 [string trim [string range $arg [expr $i + 1] end] " "]
 } else {
  if {[set tmp [ib_find [list $arg]]] != ""} { set $var2 [lindex $tmp 0] ; # we go with the db that this topic is already stored in } \
  else { set $var2 $ib_database ; # we go w/ default db }
 }
 if {([set $var1 [ib_fixtopic [set $var1]]] == "") || ([set $var2] == "")} { return "error parsing sentence" }
 return [set $var2 [ib_fixdb [set $var2]]] ; # this may return an error
}

# type = 0, returns 1/0 ; type = 1, returns proper case (or error), for use with existing topics ;
# type = 2, returns proper case (or original topic), for use with creating new topics
proc ib_exists {topic database type} {
 global ib_data_$database
 if {[set i [lsearch [string tolower [array names ib_data_$database]] [string tolower $topic]]] != -1} {
  if {$type == 0} { return 1 } \
  else { return [lindex [array names ib_data_$database] $i] }
 } else {
  if {$type == 0} { return 0 } \
  elseif {$type == 1} { return "error topic '$topic' does not exist in database '$database'" } \
  else { return $topic }
 }
}

proc ib_write {topic database type arg host} {
 global ib_data_$database
 set topic [ib_exists $topic $database 2]
 if {$type == "w"} {
  set ib_data_${database}($topic) [list $arg]
 } elseif {$type == "a"} {
  lappend ib_data_${database}($topic) $arg
 }
 lappend ib_data_${database}($topic) "#WHOSET $host [clock seconds]"
}

proc ib_read {topic database} {
 global ib_data_$database
 if {[xindex [set database [ib_fixdb $database]] 0] == "error"} { return $database } \
 elseif {[xindex [set topic [ib_exists $topic $database 1]] 0] == "error"} { return $topic } \
 else { return [set ib_data_${database}($topic)] }
}

proc ib_copy {topic1 database1 topic2 database2} {
 global ib_data_$database1 ib_data_$database2
 if {[ib_exists $topic2 $database2 0]} { return "error topic '$topic2' already exists in database '$database2'" } \
 elseif {[xindex [set output [ib_read $topic1 $database1]] 0] == "error"} { return $output } \
 else { set ib_data_${database2}($topic2) $output }
}

proc ib_remove {topic database} {
 global ib_data_$database
 if {[xindex [set topic [ib_exists $topic $database 1]] 0] == "error"} { return $topic } \
 else { unset ib_data_${database}($topic) }
}

proc ib_disp {arg database output1 output2 depth num option} {
 global ib_format
 if {$depth >= 3} { ib_msg $output1 "error recursion too deep" ; return -1 }
 set found 0
 if {$database != ""} { set list [list [list $database $arg]] ; # we have an exact topic/db to display } \
 else { set list [list [ib_find [ib_topics $arg]]]            ; # find topic/db (s) }
 # note: the $list vars above needed to be padded with { } - hence the [list] 's
 foreach tmp $list {
  if {$tmp == ""} { continue }
  if {!$depth} { set num 0 }
  if {[xindex [set output [ib_read [set topic [lindex $tmp 1]] [set database [lindex $tmp 0]]]] 0] == "error"} { ib_msg $output1 $output } \
  else {
   foreach line $output {
    if {($line == "") || ([xindex $line 0] == "#WHOSET")} { #ignore } \
    elseif {[xindex $line 0] == "#LINK"} {
     if {[set temp [ib_disp [lindex $line 1] [lindex $line 2] $output1 $output2 [expr $depth + 1] $num 0]] > 0} { incr num $temp }
    } elseif {[xindex $line 0] == "."} { ib_msg $output2 [xrange $line 1 end] ; incr num } \
    elseif {!$num} { ib_msg $output2 "$topic - $line" ; incr num } \
    else { ib_msg $output2 "... $line" ; incr num }
   }
   if {!$num} { ib_msg $output1 "error '$topic' exists, but is empty" } \
   elseif {(![string equal -nocase $output2 $output1]) && (!$depth)} {
    ib_msg $output2 "(sent by $output1)"
    ib_msg $output1 "sent '$topic' to $output2"
   }
   incr found
  }
 }
 if {!$found} {
  if {$depth > 0} { ib_msg $output1 "error invalid link to '$arg'" } \
  elseif {($option) && ([set output [ib_aiparse $arg]] != "")} { ib_msg $output1 $output } 
  # else { ib_msg $output1 "Kein Peil was '$arg' ist" }
 }
 return $num
}

# End Database code
# Begin Time code

proc tzget {time tz} {
 if {[catch {expr ($time * 2) - [clock scan [clock format $time -format "%T %D $tz"]]} time]} { error "bad timezone '$tz'" }
 return $time
}

proc tzdiff {tz1 tz2} {
 set time [clock seconds]
 return   [format %+g [expr ([tzget $time $tz1] - [tzget $time $tz2]) / (3600.)]]
}

proc ib_time {command output1 output2 arg} {
 global ib_format ib_format_notz
 set arg [split $arg]
 if {[set i [lsearch -exact [string tolower $arg] {-diff}]] != -1} {
  if {([set tz1 [string toupper [lindex $arg [expr $i + 1]]]] == "") || ([set tz2 [string toupper [xindex $arg [expr $i + 2]]]] == "")} { ib_msg $output1 "error no timezones given" } \
  elseif {[catch {tzdiff $tz1 $tz2} output]} { ib_msg $output1 "error $output" } \
  else { ib_msg $output2 "Zeit zwischen $tz1 und $tz2: $output" }
  return
 } elseif {[set i [lsearch -exact [string tolower $arg] {-tz}]] != -1} {
  if {[set tz [string toupper [lindex $arg [expr $i + 1]]]] == ""} { ib_msg $output1 "error no timezone given" ; return }
  set arg [lreplace $arg $i [expr $i + 1]]
 }
 set arg [join $arg]
 if {$arg == ""} { set arg "now" }
 if {[catch {clock scan $arg} output]}       { ib_msg $output1 "error could not scan time" } \
 elseif {![info exists tz]}                  { ib_msg $output2 [clock format $output -format "Time: $arg -> $ib_format"] } \
 elseif {[catch {tzget $output $tz} output]} { ib_msg $output1 "error $output" } \
 else { ib_msg $output2 [clock format $output -format "Time: $arg (%Z) -> $ib_format_notz ($tz)"] }
}

# End Time code
# Begin DNS code

proc ib_nslookup {ip host status output1 output2 addr} {
 if {$status} {
  if {[string match *$ip* $addr]} { ib_msg $output2 "$ip -> $host" } \
  else { ib_msg $output2 "$host -> $ip" }
 } else { ib_msg $output1 "error could not resolve $addr" }
}

# End DNS code
# Begin Dictionary search code

proc ib_dict_init {dict word output1 output2} {
 global ib_dict_serv ib_dict_port ib_dict_timeout
 if {[catch {socket -async $ib_dict_serv $ib_dict_port} sock]} { ib_msg $output1 "error fetching definition ($sock)" } \
 else { fileevent $sock writable [list ib_dict_con $sock $dict $word [utimer $ib_dict_timeout [list ib_dict_timeout $sock $output1]] $output1 $output2] }
}

proc ib_dict_con {sock dict word timerid output1 output2} {
 if {[set error [fconfigure $sock -error]] != ""} {
  ib_msg $output1 "error fetching definition ($error)"
  ib_dict_close $sock $timerid
 } else {
  fconfigure $sock -blocking 0
  fileevent $sock writable ""
  fileevent $sock readable [list ib_dict_read $sock $word $timerid $output1 $output2]
  puts $sock "define $dict \"$word\""
  flush $sock
 }
}

proc ib_dict_read {sock word timerid output1 output2} {
 while {(![set error [catch {gets $sock output} read]]) && ($read > 0)} {
  switch -- [xindex $output 0] {
   "220" - "150" { #ignore }
   "151" { ib_msg $output2 [xrange $output 1 end] }
   "." - "250" {
    ib_msg $output2 "end of definition"
    ib_dict_close $sock $timerid
    return
   }
   "550" {
    ib_msg $output1 "error fetching definition (invalid database)"
    ib_dict_close $sock $timerid
    return
   }
   "551" {
    ib_msg $output1 "error fetching definition (syntax error)"
    ib_dict_close $sock $timerid
    return
   }
   "552" {
    ib_msg $output1 "No definition found for '$word'"
    ib_dict_close $sock $timerid
    return
   }
   default { ib_msg $output2 [xrange $output 1 end] }
  }
 } 
 if {($error) || ([eof $sock])} {
  ib_msg $output1 "error fetching definition (lost connection)"
  ib_dict_close $sock $timerid
 }
}

proc ib_dict_close {sock timerid} {
 catch {close $sock} 0
 catch {killutimer $timerid} 0
}

proc ib_dict_timeout {sock output1} {
 ib_msg $output1 "error fetching definition (connection timed out)"
 ib_dict_close $sock ""
}

# End Dictionary search code
# Begin Google search code

proc ib_google_escape {string} {
 set newstring ""
 foreach char [split $string ""] {
  if {[regexp {\s} $char]}          { append newstring "+" } \
  elseif {[regexp {[\w\./]} $char]} { append newstring $char } \
  else { append newstring [format "%%%02X" [scan $char "%c"]] }
 }
 return $newstring
}

proc ib_google_init {search output1 output2} {
 global ib_google_url ib_google_timeout
 if {![parseurl $ib_google_url]}                                     { ib_msg $output1 "error bad google url" } \
 elseif {[set url "$ib_google_url[ib_google_escape $search]"] == ""} { ib_msg $output1 "error empty search string" } \
 elseif {[catch {socket -async $server $port} sock]}                 { ib_msg $output1 "error fetching search ($sock)" } \
 else { fileevent $sock writable [list ib_google_con $sock $search $url [utimer $ib_google_timeout [list ib_google_timeout $sock $output1]] $output1 $output2] }
}

proc ib_google_con {sock search url timerid output1 output2} {
 if {[set error [fconfigure $sock -error]] != ""} {
  ib_msg $output1 "error fetching search ($error)"
  ib_google_close $sock $timerid
 } else {
  fconfigure $sock -blocking 0
  fileevent $sock writable ""
  fileevent $sock readable [list ib_google_read $sock $search $timerid $output1 $output2]
  puts $sock "HEAD $url HTTP/1.0"
  puts $sock ""
  flush $sock
 }
}

proc ib_google_read {sock search timerid output1 output2} {
 while {(![set error [catch {gets $sock output} read]]) && ($read > 0)} {
  if {[regexp -nocase {^Location: (.*)$} $output tmp url]} {
   ib_msg $output2 "Google: $search -> $url"
   ib_google_close $sock $timerid
   return
  }
 }
 if {$error} {
  ib_msg $output1 "error fetching search (lost connection)"
  ib_google_close $sock $timerid
 } elseif {[eof $sock]} {
  ib_msg $output1 "error no match found"
  ib_google_close $sock $timerid
 }
}

proc ib_google_close {sock timerid} {
 catch {close $sock} 0
 catch {killutimer $timerid} 0
}

proc ib_google_timeout {sock output1} {
 ib_msg $output1 "error fetching search (connection timed out)"
 ib_google_close $sock ""
}

# End Google search code
# Begin 'calc' code

proc ib_fixexpr {exp} {
 global ib_const
 set exp [ib_fixtopic $exp]
 foreach i [array names ib_const] { regsub -all "\%$i" $exp $ib_const($i) exp }
 return $exp
}

# End 'calc' code
# Begin conversion code

proc int2bin {int} {
 return [format "%s.%s.%s.%s" \
        [byte2bin [expr ($int >> 24) & 0xff]] \
        [byte2bin [expr ($int >> 16) & 0xff]] \
        [byte2bin [expr ($int >> 8)  & 0xff]] \
        [byte2bin [expr $int         & 0xff]]]
}

proc byte2bin {byte} {
 set result ""
 for {set i 0} {$i < 8} {incr i} {
  append result [expr ($byte & 128) >> 7] 
  set byte [expr $byte << 1]
 }
 return $result
}

proc bin2int {bin} {
 set result 0
 for {set i 0} {$i < [string length $bin]} {incr i} {
  if {([set digit [string index $bin $i]] == 0) || ($digit == 1)} { set result [expr $result << 1 | $digit] } \
  elseif {$digit == "."} { #ignore } \
  else { set result "" }
 }
 return $result
}

proc ip2long {ip} {
 if {[scan $ip "%d.%d.%d.%d" a b c d] == 4} {
  foreach i "$a $b $c $d" {
   if {($i > 255) || ($i < 0)} { return "" }
  }
  set long [expr $a << 24 | $b << 16 | $c << 8 | $d]
  if {$long < 0} { set long [expr pow(2, 32) + $long] }
  return $long
 } else { return "" }
}

proc long2ip {long} { 
 return [format "%d.%d.%d.%d" \
        [expr ($long >> 24) & 0xff] \
        [expr ($long >> 16) & 0xff] \
        [expr ($long >> 8)  & 0xff] \
        [expr $long         & 0xff]]
}

proc rgb2int {rgb} {
 if {[scan $rgb "%d.%d.%d" red green blue] == 3} { return [expr $red << 16 | $green << 8 | $blue << 0] } \
 else { return "" }
}

proc int2rgb {long} {
 return [format "%d.%d.%d" \
        [expr ($long >> 16) & 0xff] \
        [expr ($long >> 8)  & 0xff] \
        [expr $long         & 0xff]]
}

# expr's abs() and int() can't handle large unsigned integers,
# these functions are just to get around this
proc ib_int {value} {
 return [lindex [split $value "."] 0]
}

proc ib_abs {value} {
 return [string trimleft $value "-"]
}

proc ib_absint {value} {
 return [ib_int [ib_abs $value]]
}

proc ib_conv_scan {var_formula var_unit index} {
 global ib_conv_ignore ib_conv_unit
 upvar 1 $var_formula formula $var_unit unit
 set string {([a-z]+(-[a-z]+)?)}
 if {[regexp -nocase -start $index $string $formula a unit]} {
  if {[lsearch -exact $ib_conv_ignore $unit] != -1} {
   # Ignore this unit and search for the next unit
   regexp -nocase -start $index -indices $string $formula a index
   return [ib_conv_scan "formula" "unit" [expr [lindex $index 1] + 1]]
  } else {
   # Found unit, return ok
   return 1
  }
 }
 # No more units found
 return 0
}

# $var will be either unit, misc_from, or misc_to
proc ib_conv {value unit var lists} {
 global ib_conv_$var
 upvar 1 list uplist
 if {![info exists uplist]} { set uplist "" }
 set type [expr {($var == "unit") || ($var == "misc_from") ? "*" : "/"}]
 # First we check full names, then abbreviations
 foreach method {name abbv} {
  foreach list $lists {
   # Default options
   set option_absint 0
   set option_metric 1
   foreach {name abbv formula} [set ib_conv_$var\($list)] {
    if {$name == "option"} { set option_$abbv $formula } \
    elseif {[regexp -nocase "^([set $method])\$" $unit a b prefix]} {
     set uplist $list
     if {([catch {expr $formula} value]) || ($value == "")} { error "evaluating expression for '$unit'" }
     if {$option_absint} { set value [ib_absint $value] }
     if {($option_metric) && ($prefix != "") && ([catch {expr [ib_conv_metric $prefix $method $option_metric] $type $value} value])} { error "evaluating metric conversion for '$unit'" }
     return $value
    }
   }
  }
 }
 error "unknown conversion type '$unit'"
}

# $method will be either "name" or "abbv"
# $option will be either 1 or 2
proc ib_conv_metric {prefix method option} {
 global ib_conv_metric
 foreach {name abbv factor} $ib_conv_metric {
  if {(($method == "name") && ([string equal -nocase $name $prefix])) || (($method == "abbv") && ([string equal $abbv $prefix]))} {
   if {$option == 1}     { return [expr pow(10, $factor)]           ; # Regular metric } \
   elseif {$option == 2} { return [expr pow(2, ($factor / 3 * 10))] ; # Binary conversion }
  }
 }
 error "unknown metric prefix"
}

# End conversion code
# Begin AI code

proc ib_aiparse {line2} {
 global line
 set line $line2
 uplevel 2 {
  global ib_ai line
  foreach {triggers responses} $ib_ai {
   foreach trigger $triggers {
    if {[string match -nocase $trigger $line]} { return [subst [lindex $responses [rand [llength $responses]]]] }
   }
  }
 }
}

# End AI code
# Begin Help-send code

proc ib_help {output1 output2} {
 global ib_helpfile
 switch -- [dccsend $ib_helpfile $output2] {
  0 {
   if {$output2 != $output1} { ib_msg $output1 "Sending infobot help file to $output2." } \
   else { ib_msg $output2 "Sending infobot help file." }
  }
  1 { ib_msg $output1 "error Too many pending file requests. Try again later, thank you." }
  2 { ib_msg $output1 "error Could not open socket. Please notify my admin, thank you." }
  3 { ib_msg $output1 "error File does not exist. Please notify my admin, thank you." }
  4 { ib_msg $output1 "error Too many file sends already in progress. Your request has been added to the queue, please wait, thank you." }
  5 { ib_msg $output1 "error Could not move file to temporary directory. Please notify my admin, thank you." }
 }
}

# End Help-send code
# Begin Public binds code

proc msg_ib {nick uhost hand arg} {
 global botnick
 pub_ib $nick $uhost $hand "" $arg
}

proc pub_ib {nick uhost hand chan arg} {


 global botnick ib_dir ib_format ib_chans ib_max ib_flag ib_database ib_databases
 global topic topic1 topic2 database database1 database2 value
 if {((![isbotnick $nick])) && (([lsearch [string tolower $ib_chans] [string tolower $chan]] != -1) || ($chan == "") || ($ib_chans == "*"))} {
  # if {[string match -nocase $arg]} { set arg [xrange $arg 1 end] ; # Only answer channel messages that begin with the bot's nick } \
  elseif {$chan == ""} { # Answer all privmsgs } \
  else {  return ; # Msg isn't for us, bail out }
  if {[matchattr $hand +b]} { return ; # A fellow bot sent the message, we just ignore it quietly }
  set isuser [expr {[matchattr $hand $ib_flag|$ib_flag $chan] || [matchattr $hand $ib_flag]}] ; # Note that $chan might be "", so we must handle both cases
  if {([validchan $chan]) && ($isuser)} { set output1 $chan ; # The bot sends the text to the channel for users } \
  else { set output1 $nick ; # Non-users get privmsg'd }
  if {[set i [string last ">" $arg]] == -1} { set output2 $output1 ; # By default, output2 (~stdout~) goes to output1 (~stderr~) } \
  else {
   # Output has been redirected
   if {(!$isuser) || ([set output2 [string trim [string range $arg [expr $i + 1] end] " "]] == "")} { set output2 $output1 ; # Error (User doesn't have access, or output was ""), so we go back to the default }
   set arg [string trim [string range $arg 0 [expr $i - 1]] " "]
  }
  set command   [string tolower [xindex $arg 0]]
  set remainder [xrange $arg 1 end]
  switch -- $command {
   "database" - "db" {
    if {$isuser} {
     switch -- [string tolower [xindex $remainder 0]] {
      "reload" { ib_loadall $output1 $output2 }
      "save"   { ib_saveall $output1 $output2 }
      "list" {
       set i 1
       ib_msg $output2 "Loaded database(s):"
       foreach database $ib_databases {
        global ib_data_$database
        ib_msg $output2 [format "%s %-15s %s" $i. $database #[llength [array names ib_data_$database]]]
        incr i
       }
       ib_msg $output2 "end"
      }
      default { ib_msg $output1 "error must be one of 'reload', 'save' , or 'list'" }
     }
    }
   }
   "set" - "learn" - "add" {
    if {$isuser} {
     if {([xindex [set error [ib_parsetopic $remainder topic value]] 0] == "error") || \
         ([xindex [set error [ib_write $topic $database "w" $value $nick!$uhost]] 0] == "error")} { ib_msg $output1 $error } \
     else { ib_msg $output2 "Set '$topic' in database '$database'" ; ib_needsave }
    }
   }
   "unset" - "forget" - "delete" - "del" - "remove" - "rem" - "rm" - "erase" {
    if {$isuser} {
     if {([xindex [set error [ib_parsetopic "$remainder = null" topic value]] 0] == "error") || \
         ([xindex [set error [ib_remove $topic $database]] 0] == "error")} { ib_msg $output1 $error } \
     else { ib_msg $output2 "Unset '$topic' in database '$database'" ; ib_needsave }
    }
   }
   "append" - "addon" {
    if {$isuser} {
     if {([xindex [set error [ib_parsetopic $remainder topic value]] 0] == "error") || \
         ([xindex [set error [ib_write $topic $database "a" $value $nick!$uhost]] 0] == "error")} { ib_msg $output1 $error } \
     else { ib_msg $output2 "Appended to '$topic' in database '$database'" ; ib_needsave }
    }
   }
   "link" - "join" {
    if {$isuser} {
     if {[xindex [set error [ib_parsetopic $remainder topic1 topic2]] 0] == "error"} { ib_msg $output1 $error } \
     elseif {[xindex [set topic2 [ib_exists $topic2 $database2 1]] 0] == "error"}    { ib_msg $output1 $topic2 ; # check if 2nd topic exists, get proper casing too (so $topic2 not $error is used) } \
     elseif {[xindex [set error [ib_write $topic1 $database1 "a" [list #LINK $topic2 $database2] $nick!$uhost]] 0] == "error"} { ib_msg $output1 $error } \
     else { ib_msg $output2 "Linked '$topic1' ($database1) to '$topic2' ($database2)" ; ib_needsave }
    }
   }
   "copy" - "cp" {
    if {$isuser} {
     if {([xindex [set error [ib_parsetopic $remainder topic1 topic2]] 0] == "error") || \
         ([xindex [set error [ib_copy $topic1 $database1 $topic2 $database2]] 0] == "error")} { ib_msg $output1 $error } \
     else { ib_msg $output2 "Copied '$topic1' ($database1) to '$topic2' ($database2)" ; ib_needsave }
    }
   }
   "move" - "mv" - "rename" - "ren" {
    if {$isuser} {
     if {([xindex [set error [ib_parsetopic $remainder topic1 topic2]] 0] == "error") || \
         ([xindex [set error [ib_copy $topic1 $database1 $topic2 $database2]] 0] == "error") || \
         ([xindex [set error [ib_remove $topic1 $database1]] 0] == "error")} { ib_msg $output1 $error } \
     else { ib_msg $output2 "Renamed '$topic1' ($database1) to '$topic2' ($database2)" ; ib_needsave }
    }
   }
   "list" - "find" - "search" - "locate" {
    set topics [ib_find2 $remainder]
    switch -- [set found [llength $topics]] {
     0 { ib_msg $output1 "Found no matches to '$remainder'" }
     1 { ib_disp [join $topics] "" $output1 $output2 0 0 0 }
     default {
      ib_msg $output2 "Found $found matches to '$remainder'"
      set i 1
      foreach topic $topics {
       ib_msg $output2 "$i. [lindex $topic 1]"
       if {$i >= $ib_max} { break }
       incr i
      }
      ib_msg $output2 "end"
     }
    }
   }
   "whoset" {
    if {[xindex [set error [ib_parsetopic "$remainder = null" topic value]] 0] == "error"} { ib_msg $output1 $error } \
    elseif {[xindex [set output [ib_read $topic $database]] 0] == "error"}                 { ib_msg $output1 $output } \
    else {
     set found 0
     foreach line $output {
      if {[xindex $line 0] == "#WHOSET"} {
       if {!$found} { ib_msg $output2 "'$topic' (database $database) set by [xindex $line 1] on [clock format [xindex $line 2] -format $ib_format]" ; incr found } \
       else { ib_msg $output2 "... modified by [xindex $line 1] on [clock format [xindex $line 2] -format $ib_format]" }
      }
     }
     if {!$found} { ib_msg $output1 "error could not find who set topic '$topic'" }
    }
   }
   "time" {
    ib_time $command $output1 $output2 $remainder
   }
   "dns" - "nslookup" - "resolve" {
    global ib_nslookup_exec
    foreach addr [set addrs [split $remainder {,;| }]] {
     if {$addr == ""}                                                   { continue ; # ignore }
     if {[set tmp [getchanhost $addr]] != ""}                           { set addr [lindex [split $tmp @] end] }
     if {![regexp {^[a-zA-Z0-9\.\-]*$} $addr]}                          { ib_msg $output1 "error hostname '$addr' contains illegal characters" ; # vulnerability } \
     elseif {[string index $addr 0] == "-"}                             { ib_msg $output1 "error hostnames cannot begin with a - character ($addr)" ; # vulnerability } \
     elseif {[info commands dnslookup] != ""}                           { dnslookup $addr ib_nslookup $output1 $output2 $addr } \
     elseif {[catch {exec bash -c "$ib_nslookup_exec '$addr'"} output]} { ib_msg $output1 "error could not resolve $addr" } \
     else {
      foreach line [split $output \n] {
       if {[lindex $line 0] == "Name:"} { set host [lrange $line 1 end] } \
       elseif {([lindex $line 0] == "Address:") || ([lindex $line 0] == "Addresses:")} { set ip [lrange $line 1 end] }
      }
      if {([info exists host]) && ([info exists ip])} { ib_nslookup $ip $host 1 $output1 $output2 $addr } \
      else { ib_nslookup "" "" 0 $output1 $output2 $addr }
     }
    }
   }
   "dict" - "dictionary" - "define" - "lookup" {
    if {[string index [xindex $remainder 0] 0] == "-"} {
     set dict [string range [xindex $remainder 0] 1 end]
     set word [xrange $remainder 1 end]
    } else {
     set dict "*"
     set word $remainder 
    }
    if {($dict == "") || ($word == "")} { ib_msg $output1 "error parsing sentence" } \
    else { ib_dict_init $dict $word $output1 $output2 }
   }
   "google" {
    if {$remainder == ""}               { ib_msg $output1 "error parsing sentence" } \
    else { ib_google_init $remainder $output1 $output2 }
   }
   "calc" - "calculate" - "expr" {
    if {$remainder == ""}                                  { ib_msg $output1 "error parsing sentence" } \
    elseif {[catch {expr [ib_fixexpr $remainder]} output]} { ib_msg $output1 "error calculating '$remainder' ($output)" } \
    else { ib_msg $output2 "$remainder = $output" }
   }
   "conv" - "convert" - "switch" - "change" {
    global ib_conv_unit ib_conv_misc_from ib_conv_misc_to
    if {([scan $remainder "from %s to %s %s" type1 type2 value] != 3) && \
        ([scan $remainder "%s from %s to %s" value type1 type2] != 3) && \
        ([scan $remainder "%s to %s %s"      type1 type2 value] != 3) && \
        ([scan $remainder "%s %s to %s"      value type1 type2] != 3) && \
        ([scan $remainder "%s %s %s"         type1 type2 value] != 3)} {
     ib_msg $output1 "error parsing sentence"
    } else {
     if {![catch {ib_conv $value       $type1 "misc_from" [array names ib_conv_misc_from]} type1_value]} {
      if {[catch {ib_conv $type1_value $type2 "misc_to"   $list} type2_value]} { ib_msg $output1 "error $type2_value" } \
      else { ib_msg $output2 "$value $type1 = $type2_value $type2" }
     } else {
      set type1_formula $type1
      set type2_formula $type2
      set found 0
      while 1 {
       if {[ib_conv_scan "type1_formula" "type1_unit" 0]} {
        if {![ib_conv_scan "type2_formula" "type2_unit" 0]}                                    { ib_msg $output1 "error unmatched type '$type1_unit'" } \
        elseif {[catch {ib_conv 1 $type1_unit "unit" [array names ib_conv_unit]} type1_value]} { ib_msg $output1 "error $type1_value" } \
        elseif {![regsub -nocase $type1_unit $type1_formula $type1_value type1_formula]}       { ib_msg $output1 "error decompiling expression '$type1_unit'" } \
        elseif {[catch {ib_conv 1 $type2_unit "unit" $list} type2_value]}                      { ib_msg $output1 "error $type2_value" } \
        elseif {![regsub -nocase $type2_unit $type2_formula $type2_value type2_formula]}       { ib_msg $output1 "error decompiling expression '$type2_unit'" } \
        else { incr found ; continue }
       } elseif {[ib_conv_scan "type2_formula" "type2_unit" 0]}                                { ib_msg $output1 "error unmatched type '$type2_unit'" } \
       else { break } ; # At the end, so stop
       return ; # We got an error somewhere, bail out
      }
      if {!$found} { ib_msg $output1 "error no conversion types found" } \
      elseif {[catch {expr [ib_fixexpr "($value) * ($type1_formula) / ($type2_formula)"]} value2]} { ib_msg $output1 "error evaluating expression" } \
      else { ib_msg $output2 "$value $type1 = $value2 $type2" }
     }
    }
   }
   "help" {
    foreach output $output2 {
     if {[string index $output 0] == "#"} { set output $nick }
     ib_help $output1 $output
    }
   }
   default {
    if { [botisvoice $chan] == 1 } {
        ib_disp $arg "" $output1 $output2 0 0 1 }
    }
     
  }
 }
}

# End Public binds code
# Init stuff

if {[catch {package require Tcl 8.2} error]} { putlog "error TCL v8.2 or higher is required to run this script" ; return 0 }

bind pubm - * pub_ib
bind msgm - * msg_ib

if {[catch {open $ib_helpfile w} fileid]} { putlog "error Could not open file $ib_helpfile" } \
else {
 fconfigure $fileid -translation crlf
 puts $fileid $ib_help
 close $fileid
}

if {![info exists ib_load]} { ib_loadall "" "" ; set ib_load 1 }
if {![info exists ib_save]} { set ib_save 0 }
if {![string match *time_ib* [timers]]} { timer $ib_time time_ib }

putlog "IB.tcl v$ib_ver by KuNgFo0 Wiedimod loaded"
