
bind pubm - "*" pub_text

set cache [list]

proc cache_hinzu { nick text } {
  global cache
  set cache [linsert $cache 0 "<$nick> $text"]
  set len [llength $cache]
  if { $len > 29 } {
    set cache [lreplace $cache end end]
  }
}

proc debugout { text } {
  putserv "privmsg #regexp :$text"
}

proc pub_text { nick host hand chan text } {
  global cache
  set text [string trim $text]

  set args [split $text "/"]
  set argc [llength $args]

  ### Prozedur sofort beenden, wenn die Nachricht nicht mit "s/" beginnt.
  if { "s" != [lindex $args 0] || $argc == 1 } then {
    cache_hinzu $nick $text
    return
  }

  if { $argc == 2 } {
    putserv "privmsg $chan :unterminated substitute pattern '$text'"
    return
  } elseif { $argc == 3 } {
    putserv "privmsg $chan :unterminated substitute in regular expression '$text'"
    return
  }

  # einfhrendes "s" lschen
  set args [lreplace $args 0 0]

  set pattern [lindex $args 0]
  set args [lreplace $args 0 0]

  regexp ".$" $pattern zeichen
  while { "\\" == $zeichen } {
    set pattern "$pattern/[lindex $args 0]"
    set args [lreplace $args 0 0]
    regexp ".$" $pattern zeichen
  }
  
  set argc [llength $args]
  set flag [lindex $args [expr $argc - 1]]

  set last [expr $argc - 1]
  set args_ [lreplace $args $last $last]
  set replacement [join $args_ "/"]
#  putserv "privmsg #regexp :$pattern $replacement $flag"

  # Flag auswerten
  switch -regexp $flag {
        ^g*$
              {
              # none or at least one "g" / kein oder mindestens ein "g"
              
              # gesamten Cache durchsuchen
              set len [llength $cache]
              for { set i 0 } { $i < $len } { incr i } {
                set zeile [split [lindex $cache $i]]
                set znick [lindex $zeile 0]
                set zeile [join [lreplace $zeile 0 0]]
                if { 1 == [string equal "<$nick>" "$znick"] } {
                  if { $flag == "" } {
                    regsub $pattern $zeile $replacement ziel
                  } else {
                    regsub -all $pattern $zeile $replacement ziel
                  }
                  
                  if { 0 == [string equal $zeile $ziel] } {
                    # Zeile aus dem Cache lschen und wieder vorne einfgen
                    set cache [linsert [lreplace $cache $i $i] 0 "$znick $ziel"]
                    putserv "privmsg $chan :$znick $ziel"
                    # nach erstem Treffer beenden
                    break
                  }
                }
              }
        }
        ^e+$
              {
              # at least one "e" / mindestens ein "e"
              putserv "privmsg $chan :*vogelzeig*"
        }
        ^.$
              {
              # single character / einzelnes Zeichen
              putserv "privmsg $chan :bad flag in substitute command '$flag'"
        }
        default
              {
              # do nothing / nichts tun
        }
  }
}
